// <PEdit2.cpp> ver.0.5
// Created By T.Kanda 1997.07.18
//

#include "PEdit.h"
#include "PEditWindow.h"
#include "JumpDialog.h"

PEJumpDialog::PEJumpDialog(PEWindow *win, BRect frame)
:BWindow(frame, "", B_MODAL_WINDOW, B_NOT_CLOSABLE | B_NOT_RESIZABLE | B_NOT_ZOOMABLE) {
	BRect       rect, editRect;
    BView       *bg;
    BStringView *prompt;
	BBox        *border;
    BButton     *ok, *cancel;

    mWin = win;

    Lock();
	frame.OffsetTo(B_ORIGIN);
	bg = new BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW);
	AddChild(bg);
	bg->SetViewColor(kControl);
	
	rect.Set(0, 0, 50, 16);
	rect.OffsetTo(4, 7);
	prompt = new BStringView(rect, "", "Line No : ");
	prompt->SetViewColor(kControl);
	bg->AddChild(prompt);
	
	rect.Set(0, 0, 34, 16);
	rect.OffsetTo(56, 8);
	border = new BBox(rect, "");
	bg->AddChild(border);

    editRect = rect;
	editRect.OffsetTo(B_ORIGIN);
	editRect.InsetBy(1, 1);
	txtLineNo = new BTextView(editRect, "", editRect, B_FOLLOW_NONE, B_WILL_DRAW);
	border->AddChild(txtLineNo);
//	txtLineNo->SetMaxChars(5);
	txtLineNo->MakeEditable(true);
	txtLineNo->MakeSelectable(true);
	txtLineNo->MakeFocus(true);
	
	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(124, 4);
    ok = new BButton(rect, "", "OK", new BMessage(BUTTON_OK));
    bg->AddChild(ok);

	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(194, 4);
    cancel = new BButton(rect, "", "Cancel", new BMessage(B_QUIT_REQUESTED));
    bg->AddChild(cancel);
    Unlock();
}

void PEJumpDialog::MessageReceived(BMessage *message) {
    int32 jump;

	if (message) {
        switch (message->what) {
        case BUTTON_OK:
            if (sscanf(txtLineNo->Text(), "%ld", &jump) != 1) {
                (new BAlert("", "illegal Line No.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
                return;
            }
            mWin->SetLineNo(jump);
            BMessage *msg = new BMessage(B_QUIT_REQUESTED);
            PostMessage(msg);
	        break;
        }
    }
}

bool PEJumpDialog::QuitRequested() {
	return(true);
}

