// <PEdit2.h> ver.0.5
// Created By T.Kanda 1997.07.18
//

#ifndef PEDIT_WINDOW_H
#define PEDIT_WINDOW_H

#include <Application.h>
#include <Window.h>
#include <stdio.h>
#include <string.h>
#include <interface/Box.h>
#include <interface/StringView.h>
#include <interface/TextView.h>
#include <interface/Button.h>
#include <interface/Alert.h>
#include <nustorage/FilePanel.h>
//#include <Be.h>
#include "CControlDefs.h"
#include "CTagsView.h"
#include "CToolButton.h"
#include "CProgressBar.h"
#include "CScrollTextView.h"
//#include "CColorButton.h"

const float MENU_BAR_HEIGHT = 16;
const float TOOL_BAR_HEIGHT = 24;
const float TOOL_BUTTON_WIDTH = 60;
const float TOOL_BUTTON_HEIGHT = 24;

class PETextView;
class PEFindDialog;
class PEJumpDialog;

class PEWindow : public BWindow {
	public:
		PEWindow(BRect frame); 
		~PEWindow(); 
		virtual bool QuitRequested();
		virtual void FrameResized(float, float);
		virtual void MessageReceived(BMessage *);

        void ReadFile(entry_ref *);
        void WriteFile(entry_ref *, const char *);
        void UpdateMenu();
        void SetLineNo(int32);
        void FindWord(const char *);

    private:
		void         InitWindow();
        void         CreateView(long);
        void         GetFontInfo();

        BRect        mFrame;
        BRect        mPageRect;
        CTagsView	  *mTagsView;
        BMenuItem    *mNew;
        BMenuItem    *mNewWindow;
        BMenuItem    *mOpen;
        BMenuItem    *mOpenWithNewWindow;
        BMenuItem    *mSave;
        BMenuItem    *mSaveAs;
        BMenuItem    *mRevert;
        BMenuItem    *mPageSetup;
        BMenuItem    *mPrint;
        BMenuItem    *mCloseWindow;
        BMenuItem    *mClose;
        BMenuItem    *mUndo;
        BMenuItem    *mCut;
        BMenuItem    *mCopy;
        BMenuItem    *mPaste;
        BMenuItem    *mClear;
        BMenuItem    *mSelectAll;
        BMenuItem    *mFind;
        BMenuItem    *mFindAgain;
        BMenuItem    *mJump;
        BMenuItem    *mSize[9];
        BMenu        *mFontName[32];
        BMenuItem    *mFontSubmenu[32];
        BMenuItem    *mStyle[32][8];
        BMenuItem    *mAbout;
        BMenuItem    *mHelp;

        long            mUntitledNum;
        long            mMaxPage;
        CPageView       *mPage[PAGE_MAX];
        PETextView      *mScrollTextView[PAGE_MAX];
        BEntry          mEntry[PAGE_MAX];
        char            *mBuff[PAGE_MAX];
        int             mEditMode[PAGE_MAX];
        char            mLabel[PAGE_MAX][32];
        int             mNumFamilies;
        FONT_INFO       mFontInfo[32];
        int             mFontSize;
        int             mSizePoint;
        int             mFamilyPoint;
        int             mStylePoint;
        BFilePanel      *mFilePanelOpen;
        BFilePanel      *mFilePanelSave;
        BDirectory      mDir_Open;
        BDirectory      mDir_Save;
        BFile           mFile;
        int32           mSearchPoint[PAGE_MAX];
        char            mTerget[256];
        PEFindDialog    *mFindDialog;
        PEJumpDialog    *mJumpDialog;
};

#endif
