// <BBTest.cpp>
// Created By T.Kanda 1997.07.04
//

#include "BBTest.h"

extern unsigned char btn_prev_off_Image[];
extern unsigned char btn_prev_on_Image[];
extern unsigned char btn_next_off_Image[];
extern unsigned char btn_next_on_Image[];
extern unsigned char btn_prev_off_dis_Image[];
extern unsigned char btn_prev_on_dis_Image[];
extern unsigned char btn_next_off_dis_Image[];
extern unsigned char btn_next_on_dis_Image[];

enum ResourceConstants {
    BUTTON_1 = 1024,
    BUTTON_2
};

class TLWindow : public BWindow {
	public:
		TLWindow(BRect frame); 
		bool QuitRequested();

	protected:
		virtual void MessageReceived(BMessage *);

    private:
        BView *bg;
};

class TLApp : public BApplication {
	public:
		TLApp();
		~TLApp();

	private:
		TLWindow *mywindow;
};

main() {	
	TLApp *lapp;
	lapp = new TLApp();
	lapp->Run();
	
	delete(lapp);
	return(0);
}

TLApp::TLApp() : BApplication('BBTS') {
	BRect rect;

	// set up a rectangle and instantiate a new window
	rect.Set(78, 80, 448, 212);
	mywindow = new TLWindow(rect);
	
	// make window visible
	mywindow->Show();	
}

TLApp::~TLApp() {
}

TLWindow::TLWindow(BRect frame)
:BWindow(frame, "BitmapButton Test", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE) {
	BRect         rect;
    CBitmapButton *mBtnPrev, *mBtnNext;

    Lock();
	frame.OffsetTo(B_ORIGIN);
	bg = new BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW);
	AddChild(bg);
	bg->SetViewColor(COL_BACK);

	rect.Set(0, 0, 15, 15);
	rect.OffsetTo(5, 70);
	mBtnPrev = new CBitmapButton(rect, "", btn_prev_off_Image, btn_prev_on_Image, new BMessage(BUTTON_1));
    bg->AddChild(mBtnPrev);

	rect.Set(0, 0, 15, 15);
	rect.OffsetTo(26, 70);
	mBtnNext = new CBitmapButton(rect, "",
	                             btn_next_off_Image,
	                             btn_next_on_Image,
	                             btn_next_off_dis_Image,
	                             btn_next_on_dis_Image,
	                             new BMessage(BUTTON_2));
//    mBtnNext->SetEnabled(false);
    bg->AddChild(mBtnNext);
    Unlock();
}

void TLWindow::MessageReceived(BMessage *message) {
	if (message) {
        switch (message->what) {
        case BUTTON_1:
            (new BAlert("", "Prev-Button pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        case BUTTON_2:
            (new BAlert("", "Next-Button pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        }
    }
}

bool TLWindow::QuitRequested() {
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}
