// <PBTest.cpp>
// Created By T.Kanda 1997.06.29
//

#include "PBTest.h"

enum ResourceConstants {
    BUTTON_1 = 1024,
    BUTTON_2,
    BUTTON_3,
    BUTTON_4
};

class TLWindow : public BWindow {
	public:
		TLWindow(BRect frame); 
		bool QuitRequested();

	protected:
		virtual void MessageReceived(BMessage *);

    private:
        BView        *bg;
        BStringView  *prompt_1, *prompt_2;
        LCTextView   *txtPos, *txtCol; 
        CProgressBar *test;
};

class TLApp : public BApplication {
	public:
		TLApp();
		~TLApp();

	private:
		TLWindow *mywindow;
};

main() {	
	TLApp *lapp;
	lapp = new TLApp();
	lapp->Run();
	
	delete(lapp);
	return(0);
}

TLApp::TLApp() : BApplication('PBTS') {
	BRect rect;

	// set up a rectangle and instantiate a new window
	rect.Set(78, 80, 448, 232);
	mywindow = new TLWindow(rect);
	
	// make window visible
	mywindow->Show();	
}

TLApp::~TLApp() {
}

LCTextView::LCTextView(BRect frame)
:BTextView(frame, "", frame, B_FOLLOW_NONE, B_WILL_DRAW) {
}

TLWindow::TLWindow(BRect frame)
:BWindow(frame, "PBTest", B_TITLED_WINDOW, B_NOT_CLOSABLE | B_NOT_RESIZABLE | B_NOT_ZOOMABLE) {
	BRect   rect, editRect;
	BBox    *label, *border_1, *border_2;
    BButton *dsp, *reset, *get_cvalue, *get_col, *cancel;

    Lock();
	frame.OffsetTo(B_ORIGIN);
	bg = new BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW);
	AddChild(bg);
	bg->SetViewColor(COL_BACK);
	
    rect.Set(0, 0, 288, 64);
	rect.OffsetTo(B_ORIGIN);
	rect.InsetBy(5, 5);
	label = new BBox(rect, "");
	label->SetLabel("ProgressBar Control");
	bg->AddChild(label);
	label->SetLowColor(COL_BACK);
	label->SetViewColor(COL_BACK);
	
	rect.Set(0, 0, 50, 16);
	rect.OffsetTo(10, 20);
	prompt_1 = new BStringView(rect, "", "Set delta");
	prompt_1->SetViewColor(COL_BACK);
	label->AddChild(prompt_1);
	
	rect.Set(0, 0, 74, 14);
	rect.OffsetTo(64, 22);
	border_1 = new BBox(rect, "");
	label->AddChild(border_1);

    editRect = rect;
	editRect.OffsetTo(B_ORIGIN);
	editRect.InsetBy(1, 1);
	txtPos = new LCTextView(editRect);
	border_1->AddChild(txtPos);
//	txtPos->SetMaxChars(10);
	txtPos->MakeEditable(true);
	txtPos->MakeSelectable(true);
	txtPos->MakeFocus(true);
	
	rect.Set(0, 0, 40, 16);
	rect.OffsetTo(148, 20);
	prompt_2 = new BStringView(rect, "", "Set col");
	prompt_2->SetViewColor(COL_BACK);
	label->AddChild(prompt_2);
	
	rect.Set(0, 0, 74, 14);
	rect.OffsetTo(192, 22);
	border_2 = new BBox(rect, "");
	label->AddChild(border_2);

    editRect = rect;
	editRect.OffsetTo(B_ORIGIN);
	editRect.InsetBy(1, 1);
	txtCol = new LCTextView(editRect);
	border_2->AddChild(txtCol);
//	txtCol->SetMaxChars(11);
	txtCol->MakeEditable(true);
	txtCol->MakeSelectable(true);
	txtCol->MakeFocus(false);

	rect.Set(0, 0, 240, 20);
	rect.OffsetTo(5, 70);
//    test = new CProgressBar(rect, "", "start", "end", true, C_PLAIN_BAR);
//    test = new CProgressBar(rect, "", "start", "end", true, C_FANCY_BAR);
    test = new CProgressBar(rect, "", "start", "end", true, C_KFTP_BAR);
    bg->AddChild(test);
    test->SetMaxValue(100.0);
//    test->SetBarHeight(30.0);
	
	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(4, 120);
    dsp = new BButton(rect, "", "Dsp", new BMessage(BUTTON_1));
    bg->AddChild(dsp);
	
	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(74, 120);
    reset = new BButton(rect, "", "Reset", new BMessage(BUTTON_2));
    bg->AddChild(reset);
	
	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(144, 120);
    get_cvalue = new BButton(rect, "", "Get Value", new BMessage(BUTTON_3));
    bg->AddChild(get_cvalue);
	
	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(214, 120);
    get_col = new BButton(rect, "", "Get Col", new BMessage(BUTTON_4));
    bg->AddChild(get_col);

	rect.Set(0, 0, 60, 20);
	rect.OffsetTo(284, 120);
    cancel = new BButton(rect, "", "Cancel", new BMessage(B_QUIT_REQUESTED));
    bg->AddChild(cancel);
    Unlock();
}

void TLWindow::MessageReceived(BMessage *message) {
    float     delta, cvalue;
    rgb_color bar;
    int       col_1, col_2, col_3;
    char      wk[256];

	if (message) {
        switch (message->what) {
        case BUTTON_1:
            if (sscanf(txtPos->Text(), "%f", &delta) != 1) {
                (new BAlert("", "this delta cannot convert to float.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
                return;
            }
            if (0.0 <= delta && delta <= 100.0) {
                test->Update(delta);
            } else {
                (new BAlert("", "please set delta between 0.0 and 100.0.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
                return;
            }
            if (strlen(txtCol->Text())) {
                if (sscanf(txtCol->Text(), "%d,%d,%d", &col_1, &col_2, &col_3) != 3) {
                    (new BAlert("", "Please set col like 999,999,999.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
                    return;
                }
                if (0 <= col_1 && col_1 <= 255 &&
                    0 <= col_2 && col_2 <= 255 &&
                    0 <= col_3 && col_3 <= 255) {
                    bar.red   = col_1;
                    bar.green = col_2;
                    bar.blue  = col_3;
                    test->SetBarColor(bar);
                } else {
                    (new BAlert("", "please set col between 0 and 255.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
                    return;
                }
            }
	        break;
        case BUTTON_2:
            test->Reset();
            break;
        case BUTTON_3:
            cvalue = test->CurrentValue();
            sprintf(wk, "CurrentValue = %f", cvalue);
            (new BAlert("", wk, "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
            break;
        case BUTTON_4:
            bar = test->BarColor();
            sprintf(wk, "col = %d, %d, %d", bar.red, bar.green, bar.blue);
            (new BAlert("", wk, "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        }
    }
}

bool TLWindow::QuitRequested() {
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}
