// <TBTest.cpp>
// Created By T.Kanda 1997.07.05
//

#include "TBTest.h"
#include "CControlDefs.h"

enum ResourceConstants {
    BUTTON_1 = 1024,
    BUTTON_2,
    BUTTON_3,
    BUTTON_4,
    BUTTON_5
};

class TLWindow : public BWindow {
	public:
		TLWindow(BRect frame); 
		bool QuitRequested();

	protected:
		virtual void MessageReceived(BMessage *);

    private:
        BView *bg;
};

class TLApp : public BApplication {
	public:
		TLApp();
		~TLApp();

	private:
		TLWindow *mywindow;
};

main() {	
	TLApp *lapp;
	lapp = new TLApp();
	lapp->Run();
	
	delete(lapp);
	return(0);
}

TLApp::TLApp() : BApplication('TBTS') {
	BRect rect;

	// set up a rectangle and instantiate a new window
	rect.Set(78, 80, 448, 260);
	mywindow = new TLWindow(rect);
	
	// make window visible
	mywindow->Show();	
}

TLApp::~TLApp() {
}

TLWindow::TLWindow(BRect frame)
:BWindow(frame, "ToolButton Test", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE) {
	BRect       rect;
    CToolButton *mCopy, *mNew;

    Lock();
	frame.OffsetTo(B_ORIGIN);
	bg = new BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW);
	AddChild(bg);
	bg->SetViewColor(COL_BACK);

    rect = rToolButtonWithoutLabel;
	rect.OffsetTo(5, 5);
	mCopy = new CToolButton(rect, "", get_icon_image(COPY_ICON), get_icon_image(COPY_MASK_ICON), new BMessage(BUTTON_1));
    bg->AddChild(mCopy);

    rect = rToolButtonWithLabel;
	rect.OffsetTo(5, 45);
	mCopy = new CToolButton(rect, "", get_icon_image(COPY_ICON), get_icon_image(COPY_MASK_ICON), "COPY", B_ALIGN_LEFT, new BMessage(BUTTON_2));
    bg->AddChild(mCopy);

    rect = rToolButtonWithLabel;
	rect.OffsetTo(5, 85);
	mCopy = new CToolButton(rect, "", get_icon_image(COPY_ICON), get_icon_image(COPY_MASK_ICON), "COPY", B_ALIGN_RIGHT, new BMessage(BUTTON_3));
    bg->AddChild(mCopy);

    rect.Set(0, 0, 103, 50);
	rect.OffsetTo(5, 125);
	mCopy = new CToolButton(rect, "", get_icon_image(COPY_ICON), get_icon_image(COPY_MASK_ICON), "COPY", B_ALIGN_CENTER, new BMessage(BUTTON_4));
    bg->AddChild(mCopy);

    rect = rToolButtonWithLabel;
	rect.OffsetTo(170, 5);
	mNew = new CToolButton(rect, "", get_icon_image(NEW_ICON), get_icon_image(NEW_MASK_ICON), "NEW", B_ALIGN_LEFT, new BMessage(BUTTON_5));
    bg->AddChild(mNew);
    Unlock();
}

void TLWindow::MessageReceived(BMessage *message) {
	if (message) {
        switch (message->what) {
        case BUTTON_1:
            (new BAlert("", "Copy-Button1 pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        case BUTTON_2:
            (new BAlert("", "Copy-Button2 pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        case BUTTON_3:
            (new BAlert("", "Copy-Button3 pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        case BUTTON_4:
            (new BAlert("", "Copy-Button4 pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        case BUTTON_5:
            (new BAlert("", "New-Button pressed.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
	        break;
        }
    }
}

bool TLWindow::QuitRequested() {
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}
