// <CProgressBar.h> ver. 1.2
// Designed By S.Osanai
// Created By T.Kanda 1997.07.11
// Updated By T.Kanda 1997.07.13
//

#ifndef CPROGRESSBAR_H
#define CPROGRESSBAR_H

#include <StatusBar.h>

#include "CControlDefs.h"

#define MARGIN_LEFT  2.0
#define MARGIN_TOP  16.0
#define MARGIN_KFTP 12.0

enum C_PROGRESS_BAR_STYLE {
    C_PLAIN_BAR = 1,
    C_FANCY_BAR,
    C_KFTP_BAR
};

//const rgb_color kDefaultProgressBar       = {   0,   0, 203 };
//const rgb_color kDefaultProgressBarHilite = { 239, 239, 239 };
//const rgb_color kDefaultProgressBarShadow = {  31,  31,  31 };
const rgb_color kDefaultProgressBar       = {  51, 152, 255 };
const rgb_color kDefaultProgressBarHilite = {  51, 255, 255 };
const rgb_color kDefaultProgressBarShadow = {  51,  51, 255 };

class CProgressBar : public BStatusBar {
    public:
    	CProgressBar(BRect frame,
    	             const char *name,
    	             const char *label = NULL,
    	             const char *trailing_label = NULL,
    	             bool draw_value = false,
    	             int progress_bar_style = C_FANCY_BAR);
		~CProgressBar();
		virtual void Draw(BRect updateRect);
		virtual	void Update(float delta,
                            const char *main_text = NULL,
							 const char *trailing_text = NULL);
	private:
        BRect mFrame;
        bool  mDraw_value;
        int   mProgress_bar_style;
};

#endif
