// <CScrollTextView.h> ver.0.7
// Created By T.Kanda 1997.07.23
//

#ifndef C_SCROLL_TEXTVIEW_H
#define C_SCROLL_TEXTVIEW_H

#include "CControlDefs.h"

#define TEXT_VIEW_WIDTH     1600.0
#define TEXT_VIEW_HEIGHT 8000000.0

class CScrollTextView;
class CTextView;
class CLineNoView;

class CScrollTextView : public BView {
    public:
        CScrollTextView(BRect frame, const char *name = NULL);
        ~CScrollTextView();
		void         ReCalcScrollBars(int);
		void         ReCalcScrollBars2();
		void         UpdateScrollBars(int, long, float);
		void         UpdateScrollBars2(BPoint);
        void         UpdateValues();
        void         SetText(const char *, long);
        const char   *Text();
        long         TextLength();
        virtual void Cut(BClipboard *);
        virtual void Copy(BClipboard *);
        virtual void Paste(BClipboard *);
        void         SelectAll();
        virtual void SetFont(const BFont *, unsigned long);
        virtual void SetViewColor(rgb_color);
        bool         JumpToLine(long);
        void         ClearDisplay(int32);
        int32        GetDspLineMax();
        bool         FindWord(int32 *, const char *);

//    protected:
        void SetLineNo();

    private:
        BView      *mView;
        BScrollBar *mHscrollbar;
        BScrollBar *mVscrollbar;
        CTextView  *mTextview;
        BView      *mLineNo;
        int        mDspLineMax;
        float      mLineHeight;
        long       mViewFirstLine;
        long       mViewBottomLine;
        float      mCurrentValue_h;
        float      mCurrentValue_v;
        float      mCheckPos_x;
        float      mFirstPos_x;
        float      mCheckPos_y;
        float      mFirstPos_y;
        int32      mCurrentLineOld;
};

class CTextView : public BTextView {
    public:
        CTextView(CScrollTextView *, BRect, BRect);
        void SelectAll();
        void Jump(int32);
    
    protected:
        virtual void KeyDown(const char *, int32);
        virtual void MouseDown(BPoint);
        virtual void AttachedToWindow();
        virtual void DetachedFromWindow();

    private:
        CScrollTextView *mWin;
        bool            mSelectFlag;
        long            mStart_o, mFinish_o;
};

class CLineNoView : public BView {
    public:
        CLineNoView(CTextView *, BRect frame, const char *name = NULL);
        ~CLineNoView();

    protected:
        virtual void Draw(BRect);

    private:
        CTextView   *mWin;
        BStringView *mLine;
};

enum CScrollTextView_Messages {
    C_SCROLL_TEXT_VIEW_ATTACHED = 4096
};

#endif
