/*
	CTagsView.h ver.0.5

	Copyright 1997 Be-project JAPAN, All Rights Reserved.
	Auther : Satoru Osanai
    Update : T.Kanda 1997.07.16
*/

#ifndef C_PAGING_VIEW
#define C_PAGING_VIEW

#include "CControlDefs.h"

//------------------------------------------------------------------
// enum definishion

enum MESSAGES {
	M_PUSHED_TAG = 64
};

enum tag_pos {
	TAG_LEFT, TAG_RIGHT, TAG_TOP, TAG_BOTTOM
};

class CTagsView;
class CPageView;
class CTagView;

//------------------------------------------------------------------
// Interface

//----------------------------------------------------------
// CTagsView 
class CTagsView : public BView {
	BList			mList;	// Page list
	long			mCurr;	// Current active page
    void           UpdatePage(int mode, char *name, char *label);
    
public:
					CTagsView(BRect frame, char *name = "", tag_pos tag = TAG_TOP);
	virtual	void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);

	CPageView*		PageAt(long index);

	void			InsertPage(char *name, char *label);
	void			AddPage(char *name, char *label);
	void			DeletePage(long index);
	
	void			ChangePage(long index);
    long           CurrentPage();
    void           SetPageColor(long index, rgb_color color);
    void           SetPageLabel(long index, char *label);
};

//----------------------------------------------------------
// CPageView 
class CPageView : public BView {
	long			mMax;	// Max page number
	long			mCurr;	// This page number
	tag_pos			mTagPos;	// Tag position

	CTagsView		*mBook;
	CTagView		*mTag;
	rgb_color		mColor;

	BRect			GetViewRect(BRect frame);

public:
					CPageView(CTagsView *book, BRect frame, long max, long curr, char *name = "", char *label = "");
	virtual	void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
//	virtual	void	MouseDown(BPoint where);

	void			SetMaxPage(long max) {mMax = max;}
	void			SetPage(long page) {mCurr = page;}
    void           SetColor(rgb_color color) {mColor = color;}
	
	CTagsView*		Book() {return mBook;}
	CTagView*		Tag() {return mTag;}
};

//----------------------------------------------------------
// CTagView 
class CTagView : public BView {
	long			mMax;	// Max page number
	long			mCurr;	// This page number
    long           mCurrentPage;  // Current page number
	tag_pos			mPos;	// Tag position

	CTagsView		*mBook;
	CPageView		*mPage;
//	char			*mLabel;		
    char           mLabel[32];
	rgb_color		mColor;
    float          mLabelHeight, mLabelOffset;

	BRect			GetViewRect(BRect frame, long max, long curr);

public:
					CTagView(CTagsView *book, CPageView *page, BRect frame, long max, long curr, char *name = "", char *label = "");
	virtual	void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	virtual	void	MouseDown(BPoint where);

	void			SetLabel(char *label);
	void			SetMaxPage(long max) {mMax = max;}
	void			SetPage(long page) {mCurr = page;}
    void           SetColor(rgb_color color) {mColor = color;}

	CTagsView*		Book() {return mBook;}
	CPageView*		Page() {return mPage;}
};

#endif
