// <CToolButton.h> ver. 1.0
// Designed By S.Osanai
// Created By T.Kanda 1997.07.11
//

#ifndef CTOOLBUTTON_H
#define CTOOLBUTTON_H

#include <Picture.h>
#include <PictureButton.h>

#include "CControlDefs.h"

#define ICON_SIZE 23.0

const BRect     rToolButtonWithoutLabel(0, 0, 25, 25);
const BRect     rToolButtonWithLabel(0, 0, 103, 25);

class CToolButton : public BPictureButton {
    public:
    	CToolButton(BRect frame,
    	            const char *name,
    	            unsigned char *icon,
    	            unsigned char *mask,
                    BMessage *message,
                    uint32 behavior = B_ONE_STATE_BUTTON,
    	            uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP,
    	            uint32 flags = B_WILL_DRAW | B_NAVIGABLE); 
    	CToolButton(BRect frame,
    	            const char *name,
    	            unsigned char *icon,
    	            unsigned char *mask,
    	            const char *label,
    	            alignment align,
                    BMessage *message,
                    uint32 behavior = B_ONE_STATE_BUTTON,
  	                uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP,
    	            uint32 flags = B_WILL_DRAW | B_NAVIGABLE); 
		~CToolButton();
	private:
        BPicture *SetPicture(BRect, int, const unsigned char *, const unsigned char *);
        BPicture *BitmapToPicture(BRect, int, BBitmap *);
        BPicture *SetPictureWithLabel(BRect, int, const unsigned char *, const unsigned char *, const char *, alignment);
        BPicture *BitmapToPictureWithLabel(BRect, int, BBitmap *, const char *, alignment);
};

enum cool_icon {
	// image
	NEW_ICON, OPEN_ICON, SAVE_ICON, CUT_ICON, COPY_ICON, PASTE_ICON,
	UNDO_ICON, REDO_ICON, FIND_ICON, PRINT_ICON,

	// mask
	NEW_MASK_ICON, OPEN_MASK_ICON, SAVE_MASK_ICON, CUT_MASK_ICON,
	COPY_MASK_ICON, PASTE_MASK_ICON, UNDO_MASK_ICON, REDO_MASK_ICON,
	FIND_MASK_ICON, PRINT_MASK_ICON
};

unsigned char* get_icon_image(cool_icon);

#endif
